from __future__ import absolute_import
import sys
import csv
import os
import socket
import json

DEFAULT_HOST = 'localhost'
DEFAULT_PORT = 10420

if __name__ == '__main__':

    try:

        host = DEFAULT_HOST
        port = DEFAULT_PORT
        token = ''

        if len(sys.argv) >1:
            for arg in sys.argv[1:]:
                if arg.lower().startswith('dest='):
                    eqsign = arg.find('=')
                    arg = arg[eqsign+1:len(arg)]
                    args = arg.split(':')
                    if len(args) >= 1:
                        host = args[0]
                    if len(args) >= 2:
                        port = int(args[1])
                if arg.lower().startswith('token='):
                    eqsign = arg.find('=')
                    token = arg[eqsign+1:len(arg)]

        #logger.info('Criblsend starting - sending output to host: ' + host + ' port: ' + str(port) + ' with token: [' + token + ']');

        s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        s.connect((host, port))
        authHeader = {};
        if len(token) > 0:
            authHeader['authToken'] = token;
        s.sendall((json.dumps(authHeader) + '\n').encode())

        writer = csv.writer(sys.stdout);

        firstLine = True
        headers = []
        mvFieldNames = []
        for row in csv.reader(sys.stdin):
            # Echo Header to Splunk
            writer.writerow(row);

            if firstLine == True:
                headers = row;
                # Track __mv columns contained in data so they can be removed prior to sending to cribl
                for column in headers:
                    if column.startswith('__mv'):
                        mvFieldNames.append(column);
                firstLine = False;

            else:

                line = {}
                for i, val in enumerate(row):
                  if not val:
                     continue
                  field = headers[i]
                  if len(val) > 0 and field.startswith('__mv_'):
                    val = val[1:len(val)-1]
                    valArr = val.split('$;$');
                    line[field[5:]] = valArr;
                  else:
                    line[field] = val
                s.sendall((json.dumps(line) + '\n').encode());

        s.close();

    except Exception as e:
        raise
